{apptype windows}
unit Data;

uses
  GData, System.Drawing, OpenGl;

//var

procedure MouseStay;
begin
    var MP := System.Windows.Forms.Cursor.Position;
    with Camera do
    begin
      RotX += (WW / 2 - MP.X) * 0.003;
      RotY -= (WH / 2 - MP.Y) * 0.003;
      
      while RotX > Pi do RotX -= 2 * Pi;
      while RotX < -Pi do RotX += 2 * Pi;
      
      if RotY > 1.57 then RotY := 1.57;
      if RotY < -1.57 then RotY := -1.57;
      
      drx *= 0.95;
      dry *= 0.95;
    end;
    
    var Speed := Camera.Speed;
    if GetKeyState(162) shr 7 = 1 then
      Speed *= Camera.Boost;
    
    if GetKeyState(32) div 128 = 1 then Camera.dY += Speed;
    if GetKeyState(160) div 128 = 1 then Camera.dY -= Speed;
    
    begin
      var dx := 0;
      var dz := 0;
      
      if GetKeyState(65) div 128 = 1 then dx += 1;
      if GetKeyState(68) div 128 = 1 then dx -= 1;
      
      if GetKeyState(87) div 128 = 1 then dz += 1;
      if GetKeyState(83) div 128 = 1 then dz -= 1;
      
      Camera.dX += (dx * Cos(Camera.RotX) + dz * Sin(Camera.RotX)) * Speed;
      Camera.dZ += (dz * Cos(Camera.RotX) - dx * Sin(Camera.RotX)) * Speed;
    end;
    
    System.Windows.Forms.Cursor.Position := new Point(Round(WW / 2), Round(WH / 2));
  
  Camera.X += Camera.dx;
  Camera.Y += Camera.dy;
  Camera.Z += Camera.dz;
  
  Camera.dx *= 0.85;
  Camera.dy *= 0.85;
  Camera.dz *= 0.85;
  
  gluLookAt(Camera.X, Camera.Y, Camera.Z,          Camera.X + Cos(Camera.RotY) * Sin(Camera.RotX), Camera.Y - Sin(Camera.RotY), Camera.Z + Cos(Camera.RotY) * Cos(Camera.RotX),          0, 1, 0);
end;

procedure OnMouseWheel(sender: System.Object; e: System.Windows.Forms.MouseEventArgs);
begin
  MW += Sign(e.Delta);
end;

procedure Redrawing;
begin
  try
    
    {$region Navigation}{
    {$endregion}
    
    {$region Calc}
    {$endregion}
    
    {$region Draw}
    if MF.Focused then
    begin
    glClear(GL_COLOR_BUFFER_BIT or GL_DEPTH_BUFFER_BIT);
    
      {$region 3D}
      {$region 3D setup}
      glLoadIdentity;
      glEnable(GL_DEPTH_TEST);
      glPushMatrix;
      glMatrixMode(GL_PROJECTION);
      gluPerspective(45.0, WW / WH, 0.1, real.MaxValue);
      MouseStay;
      {$endregion}
      
      glPopMatrix;
      
      {$endregion}
      {$region 2D}
      {$region 2D setup}
      glLoadIdentity;
      glDisable(GL_DEPTH_TEST);
      glPushMatrix;
      glMatrixMode(GL_MODELVIEW);
      gluOrtho2D(0, WW, WH, 0);
      glViewport(0, 0, WW, WH);
      {$endregion}
      
      glPopMatrix;
      
      {$endregion}
      
    end;
    
    SwapBuffers(_hdc);
    {$endregion}
    
    if MF.Focused then
      MF.WindowState := System.Windows.Forms.FormWindowState.Maximized else
      MF.WindowState := System.Windows.Forms.FormWindowState.Minimized;
    
  except
    on ee: system.Exception do
      writeln(ee);
  end;
end;

procedure FormInit;
begin

end;

procedure FormExit(sender: System.Object; e: System.Windows.Forms.FormClosingEventArgs);
begin

end;

procedure Init;
begin
  MF := new System.Windows.Forms.Form;
  MF.WindowState := System.Windows.Forms.FormWindowState.Maximized;
  MF.FormBorderStyle := system.windows.forms.FormBorderStyle.None;
  MF.Controls.Add(new GraphField(0, 0, WW, WH, 16, FormInit, Redrawing));
  MF.Icon := Icon.FromHandle((new Bitmap(1, 1)).GetHicon);
  MF.MouseWheel += OnMouseWheel;
  
  Camera.SetStandart;
    System.Windows.Forms.Cursor.Position := new Point(Round(WW / 2), Round(WH / 2));
  
  MF.Cursor.Dispose;
  MF.FormClosing += FormExit;
  system.windows.forms.Application.Run(MF);
  
end;

begin
  Init;
end.